Index: LMDZ6/branches/Portage_acc/libf/phylmd/StratAer/stratH2O_methox.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmd/StratAer/stratH2O_methox.F90	(revision 4743)
+++ LMDZ6/branches/Portage_acc/libf/phylmd/StratAer/stratH2O_methox.F90	(revision 4743)
@@ -0,0 +1,162 @@
+!
+! $Id: stratH2O_methox.F90 3677 2020-05-06 15:18:32Z oboucher $
+!
+SUBROUTINE stratH2O_methox(debutphy,paprs,dq_ch4mmr)
+!
+! output: CH4VMR in mmr (mass mixing ratio/sec: kg H2O/kg air)
+
+  USE netcdf95, ONLY: nf95_close, nf95_gw_var, nf95_inq_dimid, & 
+                      nf95_inq_varid, nf95_inquire_dimension, nf95_open
+  USE netcdf, ONLY: nf90_get_var, nf90_noerr, nf90_nowrite
+
+  USE mod_grid_phy_lmdz
+  USE mod_phys_lmdz_mpi_data, ONLY :  is_mpi_root
+  USE mod_phys_lmdz_omp_data, ONLY :  is_omp_root
+
+  USE mod_phys_lmdz_para 
+  USE dimphy
+  USE phys_cal_mod, ONLY : mth_cur
+  USE infotrac_phy
+  USE aerophys
+  USE YOMCST
+  USE strataer_local_var_mod, ONLY : flag_newclim_file
+  
+  IMPLICIT NONE
+  
+  include "dimensions.h"
+  
+! Variable input
+  REAL paprs(klon,klev+1)
+  LOGICAL, INTENT(IN) :: debutphy   ! le flag de l'initialisation de la physique
+! Variable output
+! tendance buffer pour appel de add_phys_tend
+  REAL, INTENT(INOUT), DIMENSION(klon,klev)  :: dq_ch4mmr
+  
+! Variables locales
+  INTEGER n_lat   ! number of latitudes in the input data
+  INTEGER n_lon   ! number of longitudes in the input data
+  INTEGER, SAVE :: n_lev   ! number of levels in the input data
+!$OMP THREADPRIVATE(n_lev)
+  INTEGER n_mth   ! number of months in the input data
+  INTEGER, SAVE :: mth_pre
+!$OMP THREADPRIVATE(mth_pre)
+  
+! Champs reconstitues
+  REAL paprs_glo(klon_glo,klev+1)
+  
+  REAL, ALLOCATABLE:: latitude(:)
+! (of input data sorted in strictly ascending order)
+  REAL, ALLOCATABLE:: longitude(:)
+! (of input data sorted in strictly ascending order)
+  REAL, ALLOCATABLE:: time(:)
+! (of input data sorted in strictly ascending order)
+  REAL, ALLOCATABLE:: lev(:)
+! levels of input data
+  
+!stratospheric H2O source from CH4 oxidation
+! fixed climatos
+! H2O production in VMR/sec)
+  REAL, ALLOCATABLE :: CH4RVMR_in(:, :, :, :)
+  REAL, ALLOCATABLE :: CH4RVMR_mth(:, :, :)
+  REAL, ALLOCATABLE :: CH4RVMR_tmp(:, :)
+  REAL CH4RVMR_glo(klon_glo,klev)
+!
+  INTEGER i, k, kk, j
+  
+! For NetCDF:
+  INTEGER ncid_in  ! IDs for input files
+  INTEGER varid, ncerr
+    
+  INTEGER, PARAMETER :: lev_input=17
+!--pressure at interfaces of input data (in Pa)
+  REAL, DIMENSION(lev_input+1), PARAMETER ::          & 
+                    paprs_input=(/                    &
+  1.00000002e+05,   6.06530673e+04,   3.67879449e+04, &
+  2.23130165e+04,   1.35335286e+04,   8.20850004e+03, &
+  4.97870695e+03,   3.01973841e+03,   1.83156393e+03, &
+  1.11089968e+03,   6.73794715e+02,   4.08677153e+02, &
+  2.47875223e+02,   1.50343923e+02,   9.11881985e+01, &
+  5.53084382e+01,   3.35462635e+01,   0.0           /)
+!
+  
+  IF (debutphy .OR. mth_cur .NE. mth_pre) THEN
+     
+!--preparation of global fields
+     CALL gather(paprs, paprs_glo)
+     
+     IF (is_mpi_root.AND.is_omp_root) THEN
+        
+        print *,'In stratH2O_methox read file: ch4r_annual_lmdz.nc'
+        
+        !--reading strat. H2O source (CH4 oxidation) files
+        CALL nf95_open("ch4r_annual_lmdz.nc", nf90_nowrite, ncid_in)
+        
+        CALL  nf95_inq_varid(ncid_in, "LEV", varid)
+        CALL nf95_gw_var(ncid_in, varid, lev)
+        n_lev = size(lev)
+        
+        CALL nf95_inq_varid(ncid_in, "LAT", varid)
+        CALL nf95_gw_var(ncid_in, varid, latitude)
+        n_lat = size(latitude)
+        
+        CALL nf95_inq_varid(ncid_in, "LON", varid)
+        CALL nf95_gw_var(ncid_in, varid, longitude)
+        n_lon = size(longitude)
+        
+        CALL nf95_inq_varid(ncid_in, "TIME", varid)
+        CALL nf95_gw_var(ncid_in, varid, time)
+        n_mth = size(time)
+        
+        IF (.NOT.ALLOCATED(CH4RVMR_in)) ALLOCATE(CH4RVMR_in(n_lon, n_lat, n_lev, n_mth))
+        
+        CALL nf95_inq_varid(ncid_in, "CH4RVMR", varid)
+        ncerr = nf90_get_var(ncid_in, varid, CH4RVMR_in)
+        print *,'code erreur CH4RVMR=', ncerr, varid
+        
+        CALL nf95_close(ncid_in)
+        
+        IF (.NOT.ALLOCATED(CH4RVMR_mth)) ALLOCATE(CH4RVMR_mth(n_lon, n_lat, n_lev))
+        IF (.NOT.ALLOCATED(CH4RVMR_tmp)) ALLOCATE(CH4RVMR_tmp(klon_glo, n_lev))
+        
+        !---select the correct month,
+        !---correct latitudinal order,convert input from volume mixing ratio to mass mixing ratio
+        DO j=1,n_lat
+           ! convert VMR/sec in mmr (mass mixing ratio/sec: kg H2O/kg air)
+           ! x2 because CH4->2*H2O
+           CH4RVMR_mth(:,j,:) = 2*CH4RVMR_in(:,n_lat+1-j,:,mth_cur)*mH2Omol/mAIRmol
+        ENDDO
+        
+        !---reduce to a klon_glo grid but keep the levels
+        CALL grid2dTo1d_glo(CH4RVMR_mth,CH4RVMR_tmp)
+        
+        !---regrid weighted climatologies
+        DO i=1, klon_glo
+           DO k=1, klev
+              
+              CH4RVMR_glo(i,k)=0.0
+              
+              DO kk=1, n_lev
+                 !
+                 CH4RVMR_glo(i,k)=CH4RVMR_glo(i,k)+ &
+                      MAX(0.0,MIN(paprs_glo(i,k),paprs_input(kk)) &
+                      -MAX(paprs_glo(i,k+1),paprs_input(kk+1))) &
+                      *CH4RVMR_tmp(i,kk)/(paprs_glo(i,k)-paprs_glo(i,k+1))
+              ENDDO ! kk loop
+           ENDDO ! k loop
+        ENDDO ! i loop
+     ENDIF !--is_mpi_root and is_omp_root
+     
+     !--keep memory of previous month
+     mth_pre=mth_cur
+     
+     !--scatter global fields around
+     CALL scatter(CH4RVMR_glo, dq_ch4mmr)
+     
+     IF (is_mpi_root.AND.is_omp_root) THEN
+        DEALLOCATE(CH4RVMR_in,CH4RVMR_mth,CH4RVMR_tmp)
+     ENDIF !--is_mpi_root and is_omp_root
+  ENDIF ! debutphy.OR.new month
+  
+  RETURN
+  
+END SUBROUTINE stratH2O_methox
Index: LMDZ6/branches/Portage_acc/libf/phylmd/StratAer/strataer_emiss_mod.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmd/StratAer/strataer_emiss_mod.F90	(revision 4743)
+++ LMDZ6/branches/Portage_acc/libf/phylmd/StratAer/strataer_emiss_mod.F90	(revision 4743)
@@ -0,0 +1,248 @@
+MODULE strataer_emiss_mod
+! This module contains information about strato microphysic model emission parameters
+  
+CONTAINS
+    
+  SUBROUTINE strataer_emiss_init()
+    
+    USE strataer_local_var_mod
+    USE ioipsl_getin_p_mod, ONLY : getin_p
+    USE print_control_mod, ONLY : lunout
+    USE mod_phys_lmdz_para, ONLY : is_master
+    
+    ! Local variables
+    INTEGER                  :: ispec
+    
+    WRITE(lunout,*) 'IN STRATAER_EMISS INIT WELCOME!'
+    
+    IF (flag_emit.EQ.1 .OR. flag_emit.EQ.4) THEN ! Volcano
+       CALL getin_p('nErupt',nErupt) !eruption nb
+       CALL getin_p('injdur',injdur) !injection duration
+       
+       IF (flag_emit==1) THEN
+          CALL getin_p('nAerErupt', nAerErupt) !sulfur aer nb
+       ELSEIF (flag_emit==4) THEN
+          CALL getin_p('nSpeciesErupt', nSpeciesErupt) !chimical species nb
+       ENDIF
+       
+       IF (nErupt.GT.0) THEN
+          ALLOCATE(year_emit_vol(nErupt),mth_emit_vol(nErupt),day_emit_vol(nErupt))
+          ALLOCATE(altemiss_vol(nErupt),sigma_alt_vol(nErupt))
+          ALLOCATE(xlat_min_vol(nErupt),xlon_min_vol(nErupt))
+          ALLOCATE(xlat_max_vol(nErupt),xlon_max_vol(nErupt))
+          IF (flag_emit==1) THEN
+             ALLOCATE(m_sulf_emiss_vol(nErupt))
+             ALLOCATE(m_aer_emiss_vol(nErupt,nAerErupt))
+             IF (ok_qemiss) then
+                ALLOCATE(m_H2O_emiss_vol(nErupt))
+                ALLOCATE(m_H2O_emiss_vol_daily(nErupt))
+!                ALLOCATE(d_q_emiss(klon,klev))
+                ALLOCATE(budg_emi(klon,nAerErupt+1))
+                m_H2O_emiss_vol(:)=0.
+                m_H2O_emiss_vol_daily(:)=0.
+!                d_q_emiss(:,:)=0.
+             ELSE
+                ALLOCATE(budg_emi(klon,nAerErupt))
+             ENDIF
+             budg_emi(:,:)=0.
+          ELSEIF (flag_emit==4) THEN
+             ALLOCATE(m_Chlore_emiss_vol(nErupt))
+             ALLOCATE(id_HCl) 
+             ALLOCATE(m_Brome_emiss_vol(nErupt))
+             ALLOCATE(id_HBr)
+             ALLOCATE(id_species(nSpeciesErupt))
+             ALLOCATE(m_species_emiss_vol(nErupt,nSpeciesErupt))
+             ALLOCATE(m_NOx_emiss_vol(nErupt))
+             ALLOCATE(m_H2O_emiss_vol(nErupt))
+             ALLOCATE(id_NOx)
+             ALLOCATE(id_H2O)
+             ALLOCATE(budg_emi(klon,nSpeciesErupt))
+             budg_emi(:,:)=0.
+          ENDIF
+       ELSE
+          WRITE(lunout,*) 'ERROR : Using flag_emit=1 or 4 (ie Volcanic eruption) but nErupt (',nErupt,') <=0 !'
+          CALL abort_physic('strataer_emiss_mod', &
+               'No eruption define in physiq_def (nErupt=0). Add at one eruption or use background condition.',1)
+       ENDIF ! fin if nerupt
+       
+       ! injection params (dates, loc, injections params)
+       CALL getin_p('year_emit_vol',year_emit_vol)
+       CALL getin_p('mth_emit_vol',mth_emit_vol)
+       CALL getin_p('day_emit_vol',day_emit_vol)
+       CALL getin_p('altemiss_vol',altemiss_vol)
+       CALL getin_p('sigma_alt_vol',sigma_alt_vol)
+       CALL getin_p('xlon_min_vol',xlon_min_vol)
+       CALL getin_p('xlon_max_vol',xlon_max_vol)
+       CALL getin_p('xlat_min_vol',xlat_min_vol)
+       CALL getin_p('xlat_max_vol',xlat_max_vol)
+       IF (flag_emit==1) THEN
+          CALL getin_p('m_sulf_emiss_vol',m_sulf_emiss_vol)
+        if (ok_qemiss) then
+         CALL getin_p('m_H2O_emiss_vol',m_H2O_emiss_vol)
+        endif
+       ELSEIF (flag_emit==4) THEN
+          CALL getin_p('id_species',id_species)
+          CALL getin_p('m_Chlore_emiss_vol',m_Chlore_emiss_vol)  
+          CALL getin_p('id_HCl',id_HCl)
+          CALL getin_p('m_Brome_emiss_vol',m_Brome_emiss_vol)
+          CALL getin_p('id_HBr',id_HBr)
+          CALL getin_p('m_NOx_emiss_vol',m_NOx_emiss_vol)
+          CALL getin_p('id_NOx',id_NOx)
+          CALL getin_p('m_H2O_emiss_vol',m_H2O_emiss_vol)
+          CALL getin_p('id_H2O',id_H2O)
+       ENDIF
+       
+    ELSEIF (flag_emit == 2) THEN ! SAI
+       CALL getin_p('m_aer_emiss_sai',m_aer_emiss_sai)
+       CALL getin_p('altemiss_sai',altemiss_sai)
+       CALL getin_p('sigma_alt_sai',sigma_alt_sai)
+       CALL getin_p('xlat_sai',xlat_sai)
+       CALL getin_p('xlon_sai',xlon_sai)
+       CALL getin_p('year_emit_sai_start',year_emit_sai_start)
+       CALL getin_p('year_emit_sai_end',year_emit_sai_end)
+       CALL getin_p('mth_emit_sai_start',mth_emit_sai_start)
+       CALL getin_p('mth_emit_sai_end',mth_emit_sai_end)
+       CALL getin_p('day_emit_sai_start',day_emit_sai_start)
+       CALL getin_p('day_emit_sai_end',day_emit_sai_end)
+       
+    ELSEIF (flag_emit == 3) THEN ! SAI between latitudes
+       CALL getin_p('m_aer_emiss_sai',m_aer_emiss_sai)
+       CALL getin_p('altemiss_sai',altemiss_sai)
+       CALL getin_p('sigma_alt_sai',sigma_alt_sai)
+       CALL getin_p('xlon_sai',xlon_sai)
+       CALL getin_p('xlat_max_sai',xlat_max_sai)
+       CALL getin_p('xlat_min_sai',xlat_min_sai)
+    ENDIF
+    
+    IF (flag_emit == 1) THEN
+       DO ispec=1,nAerErupt
+          m_aer_emiss_vol(:,ispec) = m_sulf_emiss_vol(:)
+       ENDDO
+    ELSEIF (flag_emit== 4) THEN
+       DO ispec=1,nSpeciesErupt
+          IF(id_species(ispec) == id_HCl) THEN
+             m_species_emiss_vol(:,ispec) = m_Chlore_emiss_vol(:)
+          ENDIF
+          IF (id_species(ispec) == id_HBr) THEN 
+             m_species_emiss_vol(:,ispec) = m_Brome_emiss_vol(:)
+          ENDIF
+          IF (id_species(ispec) == id_NOx) THEN
+             m_species_emiss_vol(:,ispec) = m_NOx_emiss_vol(:)
+          ENDIF
+          IF (id_species(ispec) == id_H2O) THEN
+             m_species_emiss_vol(:,ispec) = m_H2O_emiss_vol(:)
+          ENDIF
+       ENDDO
+    ENDIF
+    
+    !============= Injection ponderation =============
+    IF (flag_emit > 0) THEN
+       CALL strataer_ponde_init
+       WRITE(lunout,*) 'IN STRATAER INIT : ponde_lonlat_vol',ponde_lonlat_vol
+    ENDIF
+    
+    !============= Print params =============
+    IF (is_master) THEN
+       IF (flag_emit == 1 .OR. flag_emit == 4) THEN
+          WRITE(lunout,*) 'IN STRATAER nErupt: ',nErupt
+          WRITE(lunout,*) 'IN STRATAER injdur: ',injdur
+          WRITE(lunout,*) 'IN STRATAER nAerErupt: ',nAerErupt
+          
+          WRITE(lunout,*) 'IN STRATAER : year_emit_vol',year_emit_vol
+          WRITE(lunout,*) 'IN STRATAER : mth_emit_vol',mth_emit_vol
+          WRITE(lunout,*) 'IN STRATAER : day_emit_vol',day_emit_vol
+          WRITE(lunout,*) 'IN STRATAER : altemiss_vol',altemiss_vol
+          WRITE(lunout,*) 'IN STRATAER : sigma_alt_vol',sigma_alt_vol
+          WRITE(lunout,*) 'IN STRATAER : xlat_min_vol',xlat_min_vol
+          WRITE(lunout,*) 'IN STRATAER : xlat_max_vol',xlat_max_vol
+          WRITE(lunout,*) 'IN STRATAER : xlon_min_vol',xlon_min_vol
+          WRITE(lunout,*) 'IN STRATAER : xlon_max_vol',xlon_max_vol
+          IF (flag_emit==1) THEN
+             WRITE(lunout,*) 'IN STRATAEREMISS : m_sulf_emiss_vol',m_sulf_emiss_vol
+             WRITE(lunout,*) 'IN STRATAER : m_aer_emiss_vol',m_aer_emiss_vol
+             IF (ok_qemiss) then
+                WRITE(lunout,*) 'IN STRATAEREMISS : m_H2O_emiss_vol',m_H2O_emiss_vol
+             ENDIF
+          ENDIF
+       ELSEIF (flag_emit == 2) THEN
+          WRITE(lunout,*) 'IN STRATAER : m_aer_emiss_sai',m_aer_emiss_sai
+          WRITE(lunout,*) 'IN STRATAER : altemiss_sai',altemiss_sai
+          WRITE(lunout,*) 'IN STRATAER : sigma_alt_sai',sigma_alt_sai
+          WRITE(lunout,*) 'IN STRATAER : xlat_sai',xlat_sai
+          WRITE(lunout,*) 'IN STRATAER : xlon_sai',xlon_sai
+       ELSEIF (flag_emit == 3) THEN
+          WRITE(lunout,*) 'IN STRATAER : m_aer_emiss_sai',m_aer_emiss_sai
+          WRITE(lunout,*) 'IN STRATAER : altemiss_sai',altemiss_sai
+          WRITE(lunout,*) 'IN STRATAER : sigma_alt_sai',sigma_alt_sai
+          WRITE(lunout,*) 'IN STRATAER : year_emit_sai start/end',year_emit_sai_start,year_emit_sai_end
+          WRITE(lunout,*) 'IN STRATAER : mth_emit_sai start/end',mth_emit_sai_start,mth_emit_sai_end
+          WRITE(lunout,*) 'IN STRATAER : day_emit_sai start/end',day_emit_sai_start,day_emit_sai_end
+          WRITE(lunout,*) 'IN STRATAER : xlat_min_sai',xlat_min_sai
+          WRITE(lunout,*) 'IN STRATAER : xlat_max_sai',xlat_max_sai
+          WRITE(lunout,*) 'IN STRATAER : xlon_sai',xlon_sai
+       ENDIF
+       IF(flag_emit == 4) THEN
+          WRITE(lunout,*) 'IN STRATAER : nSpeciesErupt: ',nSpeciesErupt
+          WRITE(lunout,*) 'IN STRATAER : id_species = ',id_species
+          WRITE(lunout,*) 'IN STRATAER : id_HCl = ',id_HCl
+          WRITE(lunout,*) 'IN STRATAER : id_HBr = ',id_HBr
+          WRITE(lunout,*) 'IN STRATAER : id_NOx = ',id_NOx
+          WRITE(lunout,*) 'IN STRATAER : id_H2O = ',id_H2O
+          WRITE(lunout,*) 'IN STRATAER : m_Chlore_emiss_vol = ',m_Chlore_emiss_vol
+          WRITE(lunout,*) 'IN STRATAER : m_Brome_emiss_vol = ',m_Brome_emiss_vol
+          WRITE(lunout,*) 'IN STRATAER : m_NOx_emiss_vol = ',m_NOx_emiss_vol
+          WRITE(lunout,*) 'IN STRATAER : m_H2O_emiss_vol = ',m_H2O_emiss_vol
+       ENDIF
+    ENDIF ! if master
+    
+    WRITE(lunout,*) 'IN STRATAER_EMISS END'
+  END SUBROUTINE strataer_emiss_init
+  
+  ! Compute the ponderation to applicate in each grid point for all eruptions and init
+  ! dlat & dlon variables
+  SUBROUTINE strataer_ponde_init()
+    
+    USE regular_lonlat_mod, ONLY: lon_reg, lat_reg
+    USE dimphy, ONLY: klon
+    USE mod_grid_phy_lmdz, ONLY: nbp_lat, nbp_lon
+    USE print_control_mod, ONLY : lunout
+    USE strataer_local_var_mod
+    
+    INCLUDE "YOMCST.h"  !--RPI
+    
+    ! local var
+    REAL                :: lat_reg_deg,lon_reg_deg ! lat and lon of grid points in degree
+    INTEGER             :: ieru, i, j
+    
+    ALLOCATE(ponde_lonlat_vol(nErupt))
+    
+    !Compute lon/lat ponderation for injection
+    dlat=180./2./FLOAT(nbp_lat)   ! d latitude in degree
+    dlon=360./2./FLOAT(nbp_lon)   ! d longitude in degree
+    WRITE(lunout,*) 'IN STRATAER_INIT dlat=',dlat,'dlon=',dlon
+    WRITE(lunout,*) 'IN STRATAER_INIT nErupt=',nErupt
+    WRITE(lunout,*) 'IN STRATAER_INIT xlat_min=',xlat_min_vol,'xlat_max=',xlat_max_vol
+    WRITE(lunout,*) 'IN STRATAER_INIT xlon_min=',xlon_min_vol,'xlon_max=',xlon_max_vol
+    
+    DO ieru=1, nErupt
+       ponde_lonlat_vol(ieru) = 0
+       DO i=1,nbp_lon
+          lon_reg_deg = lon_reg(i)*180./RPI
+          DO j=1,nbp_lat
+             lat_reg_deg = lat_reg(j)*180./RPI
+             IF  ( lat_reg_deg.GE.xlat_min_vol(ieru)-dlat .AND. lat_reg_deg.LT.xlat_max_vol(ieru)+dlat .AND. &
+                  lon_reg_deg.GE.xlon_min_vol(ieru)-dlon .AND. lon_reg_deg.LT.xlon_max_vol(ieru)+dlon ) THEN
+                ponde_lonlat_vol(ieru) = ponde_lonlat_vol(ieru) + 1
+             ENDIF
+          ENDDO
+       ENDDO
+       IF(ponde_lonlat_vol(ieru) == 0) THEN
+          WRITE(lunout,*) 'STRATAER_INIT ERROR: no grid point found for eruption ieru=',ieru
+       ENDIF
+    ENDDO !ieru
+    
+    WRITE(lunout,*) 'IN STRATAER_PONDE_INIT ponde_lonlat: ', ponde_lonlat_vol
+    
+  END SUBROUTINE strataer_ponde_init
+  
+END MODULE strataer_emiss_mod
Index: LMDZ6/branches/Portage_acc/libf/phylmd/StratAer/strataer_local_var_mod.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmd/StratAer/strataer_local_var_mod.F90	(revision 4743)
+++ LMDZ6/branches/Portage_acc/libf/phylmd/StratAer/strataer_local_var_mod.F90	(revision 4743)
@@ -0,0 +1,245 @@
+! $Id: strataer_local_var_mod.F90 2022-10-17 19:39:09Z nlebas $
+MODULE strataer_local_var_mod
+! This module contains strato microphysic model parameters & variables
+  
+  IMPLICIT NONE
+  
+  !============= GENERAL PARAMS =============
+  !flag for type emission scenario: (0) background aer ; (1) volcanic eruption with Sulfur ;
+  !(2,3) strato aer injections (SAI) ; (4) volcanic eruption chimistry; (5) rocket
+  INTEGER,SAVE :: flag_emit
+  !$OMP THREADPRIVATE(flag_emit)
+  
+  ! flag for emission altitude distribution: (0) gaussian; (1) uniform
+  INTEGER,SAVE :: flag_emit_distrib
+  !$OMP THREADPRIVATE(flag_emit_distrib)
+  
+  ! flag to choose nucleation nucleation method
+  LOGICAL,SAVE :: flag_new_nucl   ! T=new routine from A. Maattanen (LATMOS), F=older routine from H. Vehkamäki (FMI)
+  !$OMP THREADPRIVATE(flag_new_nucl)
+  
+  ! Use relative humidity from 2D model stratospheric H2O because LMDz is too dry in the stratosphere
+  ! (no CH4 oxidation)
+  LOGICAL,SAVE :: flag_H2O2d_nucleation
+  !$OMP THREADPRIVATE(flag_H2O2d_nucleation)
+  
+  ! OH reduction from SO2. OH is reduced when its reaction with SO2 competes sufficiently with its reaction
+  ! with O3 (Bekki, 1995). As a result, SO2 lifetime is extended. 2D model O3 climatologies are needed.
+  LOGICAL,SAVE :: flag_OH_reduced
+  !$OMP THREADPRIVATE(flag_OH_reduced)
+  
+  ! H2SO4 photolysis: H2SO4 is converted into SO2 by complex photolytic processes. Here simplified approach
+  ! by setting H2SO4 cross-sections = 0.3*HCl cross-sections (Rinsland et al., 1995)
+  LOGICAL,SAVE :: flag_H2SO4_photolysis
+  !$OMP THREADPRIVATE(flag_H2SO4_photolysis)
+  
+  ! flag for minimum lifetime (=1.5 pdt phys)
+  LOGICAL,SAVE :: flag_min_rreduce
+  !$OMP THREADPRIVATE(flag_min_rreduce)
+  
+  ! flag to read new climato (O3, H2O & H2SO4_LIFET)
+  LOGICAL,SAVE :: flag_newclim_file
+  !$OMP THREADPRIVATE(flag_newclim_file)
+  
+  ! Verbose mode to get more print info
+  LOGICAL, SAVE :: flag_verbose_strataer
+  !$OMP THREADPRIVATE(flag_verbose_strataer)
+  
+  
+  !============= NUCLEATION VARS =============
+  ! flag to constraint nucleation rate in a lat/pres box
+  LOGICAL,SAVE :: flag_nuc_rate_box      ! Nucleation rate limit or not to a lat/pres
+  !$OMP THREADPRIVATE(flag_nuc_rate_box)
+  REAL,SAVE    :: nuclat_min             ! min lat to activate nuc rate
+  REAL,SAVE    :: nuclat_max             ! max lat to activate nuc rate
+  REAL,SAVE    :: nucpres_min            ! min pres to activate nuc rate
+  REAL,SAVE    :: nucpres_max            ! max pres to activate nuc rate
+  !$OMP THREADPRIVATE(nuclat_min, nuclat_max, nucpres_min, nucpres_max)
+
+  LOGICAL,SAVE :: ok_qemiss
+  !$OMP THREADPRIVATE(ok_qemiss)
+  INTEGER,SAVE :: flh2o  ! ds stratemit : flh2o =0 (tr_seri), flh2o=1 (dq) 
+  !$OMP THREADPRIVATE(flh2o)
+!  REAL,ALLOCATABLE,SAVE    :: d_q_emiss(:,:)
+!  !$OMP THREADPRIVATE(d_q_emiss)
+  
+  REAL,ALLOCATABLE,SAVE    :: budg_emi(:,:)            !DIMENSION(klon,n)
+  !$OMP THREADPRIVATE(budg_emi)
+  
+  
+  !============= EMISSION VARS =============
+  !--flag_emit=1 OR == 4 -- Volcanic eruption(s)
+  INTEGER,SAVE             :: nErupt                    ! number of eruptions specs
+  REAL,SAVE                :: injdur                    ! volcanic injection duration
+  !$OMP THREADPRIVATE(nErupt, injdur)
+  INTEGER,ALLOCATABLE,SAVE :: year_emit_vol(:)          ! year of emission date
+  INTEGER,ALLOCATABLE,SAVE :: mth_emit_vol(:)           ! month of emission date
+  INTEGER,ALLOCATABLE,SAVE :: day_emit_vol(:)           ! day of emission date
+  !$OMP THREADPRIVATE(year_emit_vol, mth_emit_vol, day_emit_vol)
+  REAL,ALLOCATABLE,SAVE    :: altemiss_vol(:)           ! emission altitude in m
+  REAL,ALLOCATABLE,SAVE    :: sigma_alt_vol(:)          ! standard deviation of emission altitude in m
+  !$OMP THREADPRIVATE(altemiss_vol, sigma_alt_vol)
+  INTEGER,ALLOCATABLE,SAVE :: ponde_lonlat_vol(:)       ! lon/lat ponderation factor
+  REAL,ALLOCATABLE,SAVE    :: xlat_min_vol(:)           ! min latitude of volcano in degree
+  REAL,ALLOCATABLE,SAVE    :: xlat_max_vol(:)           ! max latitude of volcano in degree
+  REAL,ALLOCATABLE,SAVE    :: xlon_min_vol(:)           ! min longitude of volcano in degree
+  REAL,ALLOCATABLE,SAVE    :: xlon_max_vol(:)           ! max longitude of volcano in degree
+  !$OMP THREADPRIVATE(ponde_lonlat_vol, xlat_min_vol, xlat_max_vol, xlon_min_vol, xlon_max_vol)
+  
+  !--flag_emit=1
+  INTEGER,SAVE             :: nAerErupt                 ! number Aerosol 
+  !$OMP THREADPRIVATE(nAerErupt)
+  REAL,ALLOCATABLE,SAVE    :: m_sulf_emiss_vol(:)        ! emitted sulfur mass in kgS, e.g. 7Tg(S)=14Tg(SO2)
+  REAL,ALLOCATABLE,SAVE    :: m_aer_emiss_vol(:,:)
+  !$OMP THREADPRIVATE(m_sulf_emiss_vol,m_aer_emiss_vol)
+  
+  !--flag_emit=2 --SAI
+  REAL,SAVE    :: m_aer_emiss_sai        ! emitted sulfur mass in kgS, eg 1e9=1TgS, 1e10=10TgS
+  REAL,SAVE    :: altemiss_sai           ! emission altitude in m
+  REAL,SAVE    :: sigma_alt_sai          ! standard deviation of emission altitude in m
+  !$OMP THREADPRIVATE(m_aer_emiss_sai, altemiss_sai, sigma_alt_sai)
+  INTEGER,SAVE    :: year_emit_sai_start
+  INTEGER,SAVE    :: year_emit_sai_end
+  INTEGER,SAVE    :: mth_emit_sai_start
+  INTEGER,SAVE    :: mth_emit_sai_end
+  INTEGER,SAVE    :: day_emit_sai_start
+  INTEGER,SAVE    :: day_emit_sai_end
+  !$OMP THREADPRIVATE(year_emit_sai_start, year_emit_sai_end)
+  !$OMP THREADPRIVATE(mth_emit_sai_start, mth_emit_sai_end)
+  !$OMP THREADPRIVATE(day_emit_sai_start, day_emit_sai_end)
+  REAL,SAVE    :: xlat_sai               ! latitude of SAI in degree
+  REAL,SAVE    :: xlon_sai               ! longitude of SAI in degree
+  !$OMP THREADPRIVATE(xlat_sai, xlon_sai)
+  
+  !--flag_emit=3 -- SAI
+  REAL,SAVE    :: xlat_max_sai           ! maximum latitude of SAI in degrees
+  REAL,SAVE    :: xlat_min_sai           ! minimum latitude of SAI in degrees
+  !$OMP THREADPRIVATE(xlat_min_sai,xlat_max_sai)
+  
+  !--flag_emit=4 -- volc species
+  INTEGER,SAVE             :: nSpeciesErupt            ! number of species Repr
+  INTEGER,ALLOCATABLE,SAVE :: id_species(:)            ! indice species Repr
+  REAL,ALLOCATABLE,SAVE    :: m_species_emiss_vol(:,:) ! emitted species 
+  !$OMP THREADPRIVATE(nSpeciesErupt,id_species,m_species_emiss_vol)
+  INTEGER,ALLOCATABLE,SAVE :: id_HCl
+  INTEGER,ALLOCATABLE,SAVE :: id_HBr
+  INTEGER,ALLOCATABLE,SAVE :: id_NOx
+  INTEGER,ALLOCATABLE,SAVE :: id_H2O
+  !$OMP THREADPRIVATE(id_HCl,id_HBr,id_NOx,id_H2O)
+  REAL,ALLOCATABLE,SAVE    :: m_Chlore_emiss_vol(:)   ! emitted Chlore mass 
+  REAL,ALLOCATABLE,SAVE    :: m_Brome_emiss_vol(:)    ! emitted Brome mass
+  REAL,ALLOCATABLE,SAVE    :: m_NOx_emiss_vol(:)      ! emitted NOx mass
+  REAL,ALLOCATABLE,SAVE    :: m_H2O_emiss_vol(:)      ! emitted H2O mass
+  REAL,ALLOCATABLE,SAVE    :: m_H2O_emiss_vol_daily(:)
+  !$OMP THREADPRIVATE(m_Chlore_emiss_vol,m_Brome_emiss_vol,m_NOx_emiss_vol,m_H2O_emiss_vol)
+  !$OMP THREADPRIVATE(m_H2O_emiss_vol_daily)
+  
+  !--flag_emit=5 -- Rockets Emitted
+  INTEGER, SAVE            :: ifreqroc        ! frequence (=2 ex: tous les 2 mois)
+  !$OMP THREADPRIVATE(ifreqroc)
+  INTEGER,ALLOCATABLE,SAVE :: day_emit_roc(:) ! day of emission date
+  !$OMP THREADPRIVATE(day_emit_roc)
+  
+  REAL,SAVE    :: dlat, dlon             ! delta latitude and d longitude of grid in degree
+  !$OMP THREADPRIVATE(dlat, dlon)
+  
+CONTAINS
+    
+  SUBROUTINE strataer_init()
+    USE ioipsl_getin_p_mod, ONLY : getin_p
+    USE print_control_mod, ONLY : lunout
+    USE mod_phys_lmdz_para, ONLY : is_master
+    USE infotrac_phy, ONLY: id_OCS_strat,id_SO2_strat,id_H2SO4_strat,nbtr_sulgas
+    
+    WRITE(lunout,*) 'IN STRATAER_LOCAL_VAR INIT WELCOME!'
+    
+    !============= Check Sulfur aerosols ID =============
+    WRITE(lunout,*) 'STRATAER_LOCAL_VAR INIT: id_OCS_strat=',id_OCS_strat,' id_SO2_strat=',id_SO2_strat,' id_H2SO4_strat=',id_H2SO4_strat
+    
+    IF(id_OCS_strat < 0 .OR. id_OCS_strat > nbtr_sulgas) THEN
+       WRITE(lunout,*) 'ERROR : OCS index id_OCS_strat=',id_OCS_strat,' is negative or superior than the total sulfur gases !'
+       CALL abort_physic('strataer_local_var_mod','Wrong OCS index, check your tracer.def file.',1)
+    ELSEIF(id_SO2_strat < 0 .OR. id_SO2_strat > nbtr_sulgas) THEN
+       WRITE(lunout,*) 'ERROR : SO2 index id_SO2_strat=',id_SO2_strat,' is negative or superior than the total sulfur gases !'
+       CALL abort_physic('strataer_local_var_mod','Wrong SO2 index, check your tracer.def file.',1)
+    ELSEIF(id_H2SO4_strat < 0 .OR. id_H2SO4_strat > nbtr_sulgas) THEN
+       WRITE(lunout,*) 'ERROR : H2SO4 index id_H2SO4_strat=',id_H2SO4_strat,' is negative or superior than the total sulfur gases !'
+       CALL abort_physic('strataer_local_var_mod','Wrong H2SO4 index, check your tracer.def file.',1)
+    ENDIF
+    
+    !============= Init params =============
+    flag_emit = 0                   ! Background (default)
+    flag_emit_distrib = 0           ! Gaussian (default)
+    flag_new_nucl = .TRUE.          ! Define nucleation routine (default: A. Maattanen - LATMOS)
+    flag_verbose_strataer = .FALSE. ! verbose mode
+    flag_newclim_file = .TRUE.      ! Define input climato file (default: all climato)
+    flag_H2O2d_nucleation = .FALSE. ! Use H2O 2D climato (default: No)
+    flag_OH_reduced = .FALSE.       ! OH reduce (default: No)
+    flag_H2SO4_photolysis = .FALSE. ! H2SO4 photolysis (default: No)
+    flag_min_rreduce = .TRUE.       ! Minimum lifetime=1.5 pdt phys (default: Yes)
+    ok_qemiss = .FALSE.             ! H2O emission flag
+    
+    ! nuc init
+    flag_nuc_rate_box = .FALSE.
+    nuclat_min=0  ; nuclat_max=0
+    nucpres_min=0 ; nucpres_max=0
+    
+    ! emiss init
+    nErupt = 0 ! eruption number
+    injdur = 0 ! init injection duration
+    nAerErupt = 1 ; nSpeciesErupt = 1 ; id_species = 3
+    year_emit_vol=0 ; mth_emit_vol=0 ; day_emit_vol=0
+    m_species_emiss_vol=0. ; m_aer_emiss_vol=0. ; m_sulf_emiss_vol=0.
+    altemiss_vol=0. ; sigma_alt_vol=0.
+    xlon_min_vol=0. ; xlon_max_vol=0.
+    xlat_min_vol=0. ; xlat_max_vol=0.
+    m_Chlore_emiss_vol=0. ; m_Brome_emiss_vol=0.
+    m_NOx_emiss_vol=0. ; m_H2O_emiss_vol=0.
+    day_emit_roc=0 ; ifreqroc=2 ; flh2o=0
+    
+    !============= Read params =============
+    CALL getin_p('flag_emit',flag_emit)
+    CALL getin_p('flag_emit_distrib',flag_emit_distrib)
+    CALL getin_p('flag_verbose_strataer',flag_verbose_strataer)
+    CALL getin_p('flag_new_nucl',flag_new_nucl)
+    CALL getin_p('flag_newclim_file',flag_newclim_file)
+    CALL getin_p('flag_H2O2d_nucleation',flag_H2O2d_nucleation)
+    CALL getin_p('flag_OH_reduced',flag_OH_reduced)
+    CALL getin_p('flag_H2SO4_photolysis',flag_H2SO4_photolysis)
+    CALL getin_p('flag_min_rreduce',flag_min_rreduce)
+    CALL getin_p('ok_qemiss',ok_qemiss)
+    
+    !============= Test flag coherence =============
+    IF (.NOT. flag_newclim_file) THEN
+       IF (flag_H2SO4_photolysis .OR. flag_OH_reduced .OR. flag_H2O2d_nucleation) THEN
+          WRITE(lunout,*) 'ERROR : flag_newclim_file=',flag_newclim_file, &
+               ' whereas flag_H2SO4_photolysis=',flag_H2SO4_photolysis,', flag_OH_reduced=',flag_OH_reduced, &
+               ' and flag_H2O2d_nucleation=',flag_H2O2d_nucleation
+          CALL abort_physic('strataer_local_var_mod','Incompatible options in physiq_def file !',1)
+       ENDIF
+       IF(flag_min_rreduce) THEN
+          WRITE(lunout,*) 'Warning : flag_min_rreduce will be ignored with old climato file !'
+       ENDIF
+    ENDIF
+    
+    !============= Print params =============
+    IF (is_master) THEN
+       WRITE(lunout,*) 'flag_emit = ',flag_emit
+       WRITE(lunout,*) 'IN STRATAER : flag_new_nucl = ',flag_new_nucl
+       WRITE(lunout,*) 'IN STRATAER : flag_newclim_file = ',flag_newclim_file
+       WRITE(lunout,*) 'IN STRATAER : flag_emit_distrib = ',flag_emit_distrib
+       WRITE(lunout,*) 'IN STRATAER : flag_verbose_strataer = ',flag_verbose_strataer
+       IF (flag_emit == 1 .OR. flag_emit == 4) THEN
+          WRITE(lunout,*) 'IN STRATAER : flag_H2O2d_nucleation = ',flag_H2O2d_nucleation
+          WRITE(lunout,*) 'IN STRATAER : flag_OH_reduced = ',flag_OH_reduced
+          WRITE(lunout,*) 'IN STRATAER : flag_H2SO4_photolysis = ',flag_H2SO4_photolysis
+          WRITE(lunout,*) 'IN STRATAER : flag_min_rreduce = ',flag_min_rreduce
+          WRITE(lunout,*) 'IN STRATAER : ok_qemiss = ',ok_qemiss
+       ENDIF
+    ENDIF ! if master
+    
+    WRITE(lunout,*) 'IN STRATAER INIT END'
+    
+  END SUBROUTINE strataer_init
+  
+END MODULE strataer_local_var_mod
